/***************************************************************************
 *   Copyright (C) 2005 by Joris Guisson                                   *
 *   joris.guisson@gmail.com                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.          *
 ***************************************************************************/

#ifndef SEARCHTAB_H
#define SEARCHTAB_H

#include "searchtabbase.h"

namespace kt
{
	class SearchEngineList;

	class SearchTab : public SearchTabBase
	{
		Q_OBJECT
	
	public:
		SearchTab(QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
		virtual ~SearchTab();
	
		void updateSearchEngines(const SearchEngineList & sl);
		
		
	
	protected slots:
		void clearButtonPressed();
		void searchNewTabPressed();
		void clearHistoryPressed();
		void searchBoxReturn(const QString & str);
		void textChanged(const QString & str);
		
	signals:
		void search(const QString & text,int engine,bool external);
		
	private:
		void loadSearchHistory();
		void saveSearchHistory();
	};
}

#endif

